/*                  implant.c                 */
/*     This is the source file for Implant    */
/*  Written by Serge Sereda in July 04, 1998  */

#include<stdio.h>
#include<stdlib.h>
#include<io.h>
#include<values.h>
#include<fcntl.h>
#include<sys\stat.h>

FILE *patient, *implant;
char file1 [13],file2 [13];
unsigned long offset1,offset2=0;
long lngz=0L,i=1;

patch(void)
{
   char a;

    if ((patient = fopen(file1,"r+b")) == NULL) {
       fprintf(stderr, "Cannot open file for patching.\n");
       return 0;
    }

    if ((implant = fopen(file2,"rb")) == NULL) {
       fprintf(stderr, "Cannot open file with new code.\n");
       fclose(patient);
       return 0;
    }

    if (fseek(patient,offset1,SEEK_SET) != 0) {
       fprintf(stderr, "Cannot move file pointer.Check the offset value\n");
       fclose(patient);
       fclose(implant);
       return 0;
    }

    if (fseek(implant,offset2,SEEK_SET) != 0) {
       fprintf(stderr, "Cannot move file pointer.Check the offset value\n");
       fclose(patient);
       fclose(implant);
       return 0;
    }

    while (1) {
          if ((i>lngz) && (lngz>0))
             break;
          a=fgetc(implant);
             if(feof(implant)) {
               fclose(patient);
               fclose(implant);
               return i;
             }

          if (fputc(a, patient) == EOF) {
             fprintf(stderr, "Cannot write to file.\n");
             fclose(patient);
             fclose(implant);
             return 0;
          }

          i+=1;
    }

    fclose(patient);
    fclose(implant);
    return i;
}



void main(argc,argv)
char *argv[];
{

//  A small contribution for the author

  fprintf(stderr, "\n             ͵      Implant utility v1.00beta FREEWARE      \n");
    fprintf(stderr, "                 ͵ Written by Serge Sereda, Kishinev MD \n");
    fprintf(stderr, "             ͵Copyright (c) Jul 04, 1998 All Rights Reserved\n\n");

//  *** Check for parameters presence

    if(argc < 4) {
       fprintf(stderr, "Usage : implant.com <file1> <file2> <offset1> [offset2] [length]\n");
       fprintf(stderr, "Where : file1   - File to patch\n");
       fprintf(stderr, "      : file2   - File with new code (binary, not .CRK/XCK !!!)\n");
       fprintf(stderr, "      : offset1 - Offset in file to patch           \n");
       fprintf(stderr, "      : offset2 - Offset in file with new code  All HEX values !!!\n");
       fprintf(stderr, "      : length  - Length of piece of new code       \n");
    }
    else {

//  *** Take parameter 1 (first filename)

          sscanf(argv[1],"%s",&file1);

//  *** Take parameter 2 (second filename)

          sscanf(argv[2],"%s",&file2);

//  *** Take parameter 3 (offset in first file)

          sscanf(argv[3],"%X",&offset1);


//  Optional parameters


//  *** Take parameter 4 (offset in first file)

          if(argc > 4)
            sscanf(argv[4],"%X",&offset2);

//  *** Take parameter 5 (length of new code)

          if(argc > 5)
            sscanf(argv[5],"%X",&lngz);

if(patch() == 0)
  fprintf(stderr, "\nError occured when patching, sorry.\n");
    }
}